#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "tree_functions.h"
#include "main.h"


int main ( int argc, char ** argv)
{
 FILE * in;
 int nuc=0;
 long int nb=0;
 char c; 
 char *seq;
 knot* mynode;

 mynode=create_knot(mynode,NULL);

 if ( argc != 2 && argc != 3 ) { help_usage(argv[0]); return(0);}
 else 
 {
  nuc=atoi(argv[1]);

  if (argv[2]) 
  { 
    if ( ( in = fopen (argv[2],"r") ) == NULL ) { fprintf(stderr,"%s ",argv[2]); perror(" Error \n"); return(-1); }
  }
  else in=stdin;
 }
 if ((seq=(char*)calloc(1,sizeof(seq)))==NULL)
 {
   free(seq);
   seq=NULL;
  perror("Calloc Failed\n"); 
  exit(-1);
 }
  //mynode=NULL;
  mynode=create_tree(mynode,nuc); // mynode=mynode->father;

 while ( !feof(in) && ((c=getc(in))!=EOF) )
   {

  if (c=='>') 
    while (((c=getc(in))!='\n')&&c!=EOF) fprintf(stderr,"%c",c); 

   seq=store_fasta(seq,in);
   nb+=strlen(seq);
   fprintf(stderr," (%d caracters)\n",strlen(seq));
   mynode=count_X_nucleotide(mynode,seq,nuc);

 } 
 fprintf(stderr,"\n%ld caracters parsed\n",nb);
 print_tree(mynode,nuc);
 remove_tree(mynode,nuc);

 free(seq);
 seq=NULL;
 return(1);
}

void help_usage(char *s)
{
 printf("\n%s: Count X nucleotide from all the sequence ( compiled the %s )\nUsage:\n\tcat fasta_file | %s <X_nucleotides>\n\t%s <X_nucleotides> <fasta_file\n",s,__DATE__,s,s);

}

char* store_fasta (char *tmp, FILE* fl )
{
 char c,t;
 int i=0;
 char *pt;

 while( (c=getc(fl)) && c!='>' && c!=EOF &&!feof(fl) ) 
 { 
   t=tolower(c);

  if (t=='a' || t=='c' || t=='g' || t=='t')
  {
    if (tmp==NULL) 
      {
	perror("Tmp pointer NULL\n");
	exit(-1);
      }
   if ((pt=(char*)realloc(tmp,(i+1)*sizeof(tmp)))==NULL)
   {
     free(pt);
     free(tmp);
     perror("Realloc failed\n");
     exit(-1);
   }  
   tmp=pt;
   tmp[i++]=t;

  }
 }
 tmp[i]='\0';
 if (c!=EOF) fseek(fl,-1,SEEK_CUR);
 return (tmp);
}

knot* count_X_nucleotide (knot* node, char* seq, int nuc)
{
 int i;
 char *str;

 if ((str=(char*)calloc((nuc+1),sizeof(str)))==NULL) // ici probleme avec glibc, type char corrompu ?? prefere type de tmp :D
 {
   free(str);
  perror("Malloc Failed In count_X_nucleotide() function.\n");
  exit(-1);
 }

 for (i=0;i<=(strlen(seq)-nuc);i++)
 {
   //  if (str+i>seq && str<seq+i) //chevauchement des zones memoires 
   // {
       memcpy(str,seq+i,nuc);
       str[nuc+1]='\0';
       node=add_motif(node,str,nuc);
       //       printf("str:%s,",str);
       str=reverse_forward(str);
       node=add_motif(node,str,nuc);
       //printf("Forward:%s\n",str);
       // }
 }


 free(str);
 str=NULL;
 return node;
}

char* reverse_forward(char * s)
{ 
  char *t;
  int i,j=0;
  
  if ((t=(char*)malloc((strlen(s)+1)*sizeof(s)))==NULL)
    {
      perror("Malloc Failed in Rerverse_forward().\n");
      exit(-1);
    }
 
  for (i=strlen(s)-1; i>=0; i--) 
    {
        switch(s[i])
	{
	case 'a': t[j++]='t'; break;
        case 't': t[j++]='a'; break;
	case 'c': t[j++]='t'; break;
	case 'g': t[j++]='c'; break;
	}
    } 

  t[j]='\0';
  strcpy(s,t);
  free(t);
  t=NULL;
  return (s);
  
}


