#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tree_functions.h"

/* creation d'un nouveau noeud */
knot* create_knot(knot* new,knot * father)
{  knot *p;
 if ( NULL == (p=(knot*)calloc(1,sizeof(knot)))) 
 {
   free(p);
   p=NULL;
  perror("Malloc Failed In create_knot() Function.");
  exit(-1);
 }
 new=p;
 new->a=NULL;
 new->c=NULL;
 new->g=NULL;
 new->t=NULL;
 new->nb=0;
 new->father=father;

 return new;
}

knot* create_tree(knot * father, int deep)
{
 knot* node;

 if (deep==0)
 {
   return father;
 }
 else 
 {
  father->a=create_tree(create_knot(node,father),deep-1);
  father->c=create_tree(create_knot(node,father),deep-1);
  father->g=create_tree(create_knot(node,father),deep-1); 
  father->t=create_tree(create_knot(node,father),deep-1); 

  return father;
 }
}

knot* remove_tree(knot* node,int deep)
{
 knot* tmp;

 if (deep==0)
 { 
  tmp=node->father;
  node->father=NULL;
  free(node);
  node=NULL;
  return(tmp);   
 }
 else 
 {
  node->father=node;
  node->a=remove_tree(node->a,deep-1);
  node->c=remove_tree(node->c,deep-1); 
  node->g=remove_tree(node->g,deep-1);
  node->t=remove_tree(node->t,deep-1); 
  return node;
 }
}


knot* add_motif(knot* node, char *str,int i)
{
 if (i==0)
 {
  node->nb++; 
  return node;
 }
 else 
 {
  if (str[i-1] == 'a')
   node->a=add_motif(node->a,str,i-1);
  else if (str[i-1] == 'c')
   node->c=add_motif(node->c,str,i-1);
  else if (str[i-1] == 'g')  
   node->g=add_motif(node->g,str,i-1); 
  else if (str[i-1] == 't')
   node->t=add_motif(node->t,str,i-1);

  return node;
 }

}

knot* print_tree(knot* node,int deep)
{
  knot *next, *current;



  if (deep==0)
 {
   current=node;
   next=node->father;
   while (current->father!=NULL)
     {
       if (current==next->a) putc('A',stdout);
       else if (current==next->c) putc('C',stdout);
       else if (current==next->g)  putc('G',stdout); 
       else if (current==next->t) putc('T',stdout);
       else { perror("No such caracter\n"); exit(-2); }
       current=next;
       next=current->father;
     }
   
   printf(" : %d\n",node->nb);
   

  return(node);
 }
 else
 {
   
  node->a=print_tree(node->a,deep-1); 
  node->c=print_tree(node->c,deep-1); 
  node->g=print_tree(node->g,deep-1); 
  node->t=print_tree(node->t,deep-1); 

  return node;
 }
}

knot* climb_into_tree(knot* node)
{
  while (node->father != NULL) { node=node->father; }
  return node;
}
